' ppt2txt.vbs
'
' Converts <input file> from a PowerPoint document to text file and
' saves the results to <output file>.  Requires Microsoft PowerPoint.
' 
' Usage:
'  WScript ppt2txt.vbs <input file> <output file>

DIM fso, outFile 
Set fso = CreateObject("Scripting.FileSystemObject")
Set outFile = fso.CreateTextFile(WScript.Arguments(1), True)

Dim ppt
Set ppt = CreateObject("Powerpoint.Application")
On Error Resume Next

ppt.Presentations.Open WScript.Arguments(0),True,,False
If Err = 0 Then
	nPres = ppt.Presentations.Count
	For Each sld In ppt.Presentations(nPres).Slides
		'Convert Shapes to text
		For Each shp In sld.Shapes
			If shp.HasTextFrame Then 'The shape can contain text
				If shp.TextFrame.HasText Then outFile.WriteLine(shp.TextFrame.TextRange.Text)
			End If
		Next
		'Convert Notes to text
		For Each shp In sld.NotesPage.Shapes
			'NotesPages are limited versions of Slides
			If shp.HasTextFrame Then 'The shape can contain text
				If shp.TextFrame.HasText Then outFile.WriteLine(shp.TextFrame.TextRange.Text)
			End If
		Next
		'Convert Comments to text
		For Each cmt In sld.Comments
			outFile.WriteLine(cmt.Author & vbTAB & cmt.DateTime & vbTAB & cmt.Text)
		Next
	Next
End If

outFile.Close
